/* MAA - Message Authentication Algorithm - ISO 8731-2
 *
 * C implementation by Niels Mller <nisse@lysator.liu.se> 1996
 */

#ifndef ISO_MAA_H_INCLUDED
#define ISO_MAA_H_INCLUDED

/* 32 bit integer */
#define MAA_WORD unsigned int

struct MAA_key
{
  MAA_WORD J, K;
  MAA_WORD X0, Y0, V0;
  MAA_WORD W, S, T;
};

struct MAA_state
{
  struct MAA_key *key;
  MAA_WORD X, Y, V;
  unsigned buffer_count;
  unsigned char buffer[4];
  unsigned block_count;
};

void  /* Preprocess key */
MAA_key(struct MAA_key *key, MAA_WORD j, MAA_WORD k);

void  /* Initialize */
MAA_reset(struct MAA_state *state);

void  /* Hash more data */
MAA_update(struct MAA_state *state,
	   unsigned char *message,
	   unsigned length);

MAA_WORD /* Get Message Authentication Code for message, and reset */
MAA_mac(struct MAA_state *state);

#endif ISO_MAA_H_INCLUDED
